<?php
	$message_root = ADMIN_ROOT."dashboard/messages/";
	// Get all the messages we've sent or received.  We're going to paginate them in a hidden type fashion and just load them all at once.
	$messages = $admin->getMessages();
	$unread = $messages["unread"];
	$read = $messages["read"];
	$sent = $messages["sent"];
	
	$unread_pages = ceil(count($unread) / 5);
	$read_pages = ceil(count($read) / 5);
	$sent_pages = ceil(count($sent) / 5);
?>
<div class="table">
	<summary>
		<h2><span class="unread"></span>Unread Messages</h2>
		<?php if (count($unread)) { ?>
		<nav id="unread_paging" class="view_paging"></nav>
		<?php } ?>
	</summary>
	<header>
		<span class="messages_from_to">From</span>
		<span class="messages_subject">Subject</span>
		<span class="messages_date_time">Date</span>
		<span class="messages_date_time">Time</span>
		<span class="messages_view">View</span>
	</header>
	<ul>
		<?php
			if (count($unread) == 0) {
		?>
		<li><section class="no_content">You have no unread messages.</section></li>
		<?php
			} else {
				$page = 0;
				$x = 0;
				foreach ($unread as $item) {
					if ($x == 5) {
						$page++;
						$x = 0;
					}
					$x++;
		?>
		<li class="page_<?=$page?>"<?php if ($page > 0) { ?> style="display: none;"<?php } ?>>
			<section class="messages_from_to"><span class="gravatar"><img src="<?=BigTree::gravatar($item["sender_email"], 36)?>" alt="" /></span><?=$item["sender_name"]?></section>
			<section class="messages_subject"><?=$item["subject"]?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "n/j/y")?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "g:i a")?></section>
			<section class="messages_view"><a href="<?=$message_root?>view/<?=$item["id"]?>/" class="icon_message"></a></section>
		</li>
		<?php
				}
			}
		?>
	</ul>
</div>

<div class="table">
	<summary>
		<h2><span class="read"></span>Read Messages</h2>
		<?php if (count($read)) { ?>
		<nav id="read_paging" class="view_paging"></nav>
		<?php } ?>
	</summary>
	<header>
		<span class="messages_from_to">From</span>
		<span class="messages_subject">Subject</span>
		<span class="messages_date_time">Date</span>
		<span class="messages_date_time">Time</span>
		<span class="messages_view">View</span>
	</header>
	<ul>
		<?php
			if (count($read) == 0) {
		?>
		<li><section class="no_content">You have no read messages.</section></li>
		<?php
			} else {
				$page = 0;
				$x = 0;
				foreach ($read as $item) {
					if ($x == 5) {
						$page++;
						$x = 0;
					}
					$x++;
		?>
		<li class="page_<?=$page?>"<?php if ($page > 0) { ?> style="display: none;"<?php } ?>>
			<section class="messages_from_to"><span class="gravatar"><img src="<?=BigTree::gravatar($item["sender_email"], 36)?>" alt="" /></span><?=$item["sender_name"]?></section>
			<section class="messages_subject"><?=$item["subject"]?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "n/j/y")?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "g:i a")?></section>
			<section class="messages_view"><a href="<?=$message_root?>view/<?=$item["id"]?>/" class="icon_message"></a></section>
		</li>
		<?php
				}
			}
		?>
	</ul>
</div>

<div class="table">
	<summary>
		<h2><span class="sent"></span>Sent Messages</h2>
		<?php if (count($sent)) { ?>
		<nav id="sent_paging" class="view_paging"></nav>
		<?php } ?>
	</summary>
	<header>
		<span class="messages_from_to">To</span>
		<span class="messages_subject">Subject</span>
		<span class="messages_date_time">Date</span>
		<span class="messages_date_time">Time</span>
		<span class="messages_view">View</span>
	</header>
	<ul>
		<?php
			if (count($sent) == 0) {
		?>
		<li><section class="no_content">You have no sent messages.</section></li>
		<?php
			} else {
				$page = 0;
				$x = 0;
				foreach ($sent as $item) {
					if ($x == 5) {
						$page++;
						$x = 0;
					}
					$x++;
					// Get the recipient names
					$recipients = explode("|",trim($item["recipients"],"|"));
					$r_names = array();
					foreach ($recipients as $r) {
						$u = $admin->getUser($r);
						$r_names[] = $u["name"];
					}
		?>
		<li class="page_<?=$page?>"<?php if ($page > 0) { ?> style="display: none;"<?php } ?>>
			<section class="messages_from_to"><?=implode(", ",$r_names)?></section>
			<section class="messages_subject"><?=$item["subject"]?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "n/j/y")?></section>
			<section class="messages_date_time"><?=$admin->convertTimestampToUser($item["date"], "g:i a")?></section>
			<section class="messages_view"><a href="<?=$message_root?>view/<?=$item["id"]?>/" class="icon_message"></a></section>
		</li>
		<?php
				}
			}
		?>
	</ul>
</div>
<script>
	BigTree.localPagesOfMessages = { unread_paging: <?=$unread_pages?>, read_paging: <?=$read_pages?>, sent_paging: <?=$sent_pages?> };
	
	BigTree.setPageCount("#unread_paging",<?=$unread_pages?>,1);
	BigTree.setPageCount("#read_paging",<?=$read_pages?>,1);
	BigTree.setPageCount("#sent_paging",<?=$sent_pages?>,1);
	
	$(".table").on("click",".view_paging a",function() {
		var page = parseInt($(this).attr("href").substr(1));
		$(this).parents("summary").siblings("ul").find("li").hide().filter(".page_" + page).show();
		$(this).parents("ul").find(".active").removeClass("active");
		
		var id = $(this).parents("ul").attr("id");
		BigTree.setPageCount("#" + id,BigTree.localPagesOfMessages[id],page);
		
		return false;
	});
</script>